# translation of xiaowuc1's solution
from enum import Enum
class Val(int, Enum):
    ZERO = 0
    ONE = 1
    X = 2
    Y = 3
    NOT = 4
    EQ = 5
    AND = 6
    OR = 7
    XOR = 8
    LEFT_PAREN = 9

def eval(op, x, y):
    if op == Val.EQ: return int(x == y)
    if op == Val.AND: return x & y
    if op ==  Val.OR: return x | y
    if op == Val.XOR: return x ^ y
    assert False

def getop(c):
    if c == '&': return Val.AND
    if c ==  '|': return Val.OR
    if c ==  '^': return Val.XOR
    if c == '=': return Val.EQ
    assert False

def parse(s, ops):
    opst = []
    for ch in s:
        if ch == '0': ops.append(Val.ZERO)
        if ch == '1': ops.append(Val.ONE)
        if ch == 'x': ops.append(Val.X)
        if ch == 'y': ops.append(Val.Y)
        if ch == '(': opst.append(Val.LEFT_PAREN)
        if ch == ')':
            while opst:
                if opst[-1] == Val.LEFT_PAREN:
                    opst.pop()
                    break
                ops.append(opst.pop())
        if ch == '!': opst.append(Val.NOT)
        if ch in ['&','|','^','=']:
            # assume it is a binary op
            currop = getop(ch)
            while opst and opst[-1] <= currop:
                ops.append(opst.pop())
            opst.append(currop)

    while opst:
        assert opst[-1] != Val.LEFT_PAREN
        ops.append(opst.pop())


n,k = map(int, input().split())
stops = []
bitindices = []
retval = []
solved = [[[False for _ in range(4)] for _ in range(k)] for _ in range(k)]

for i in range(n):
    a,b,op,ans = input().split()
    a = int(a)-1
    b = int(b)-1
    ans = int(ans)

    ops = []
    parse(op, ops)
    valid = 0
    for x in range(2):
        for y in range(2):
            if solved[a][b][2*x+y]:
                continue
            vals = []
            for out in ops:
                if out == Val.ZERO: vals.append(0)
                if out == Val.ONE: vals.append(1)
                if out == Val.X: vals.append(x)
                if out == Val.Y: vals.append(y)
                if out == Val.NOT:
                    assert len(vals) > 0
                    vals[-1] ^= 1
                if out in [Val.EQ, Val.AND, Val.OR, Val.XOR]:
                    assert len(vals) >= 2
                    a_val,b_val = vals.pop(), vals.pop()
                    vals.append(eval(out, a_val, b_val))

            assert len(vals) == 1
            if vals[-1] == 1:
                solved[a][b][2*x+y] = True
                valid |= (1<<(2*x+y))
            
    if valid == 0:
        continue
    stops.append(valid)
    bitindices.append((a, b))
    retval.append(ans)

finalresult = int(input())

results = [0 for _ in range(1<<k)]

for a in range(1<<k):
    for b in range(1<<k):
        ans = -1
        for i in range(len(retval)):
            x = (a>>bitindices[i][0])&1
            y = (b>>bitindices[i][1])&1
            if stops[i] & (1 << (2*x+y)):
                ans = retval[i]
                break
        else:
            ans = finalresult

        if ans == 1:
            results[a] |= 1<<b


print(sum((results[i]>>i)&1 for i in range(1<<k)))

print(sum((
    (results[i]>>j)&(results[j]>>i)&1
    for i in range(1<<k)
    for j in range(1<<k)
)))

ret = 0
for i in range(1<<k):
    for j in range(1<<k):
        if results[i]>>j & 1:
            inner = ~results[i] & results[j]
            ret += bin(inner).count("1")
print(ret)
